// Decompiled by DJ v2.9.9.61 Copyright 2000 Atanas Neshkov  Date: 31/03/2004 10:40:18
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   DTDParser.java

package com.wutka.dtd;

import java.io.*;
import java.net.URL;
import java.util.*;

// Referenced classes of package com.wutka.dtd:
//			  Scanner, DTD, DTDElement, DTDContainer, 
//			  DTDItem, DTDName, DTDProcessingInstruction, DTDParseException, 
//			  DTDComment, DTDEmpty, DTDAny, DTDMixed, 
//			  DTDPCData, DTDChoice, DTDSequence, DTDAttlist, 
//			  DTDAttribute, DTDNotationList, DTDEnumeration, DTDEntity, 
//			  DTDSystem, DTDPublic, DTDNotation, EntityExpansion, 
//			  Token, TokenType, DTDCardinal, DTDDecl, 
//			  DTDExternalID

public class DTDParser
	implements EntityExpansion
{

	public DTDParser(Reader reader)
	{
		scanner = new Scanner(reader, false, this);
		dtd = new DTD();
	}

	public DTDParser(Reader reader, boolean flag)
	{
		scanner = new Scanner(reader, flag, this);
		dtd = new DTD();
	}

	public DTDParser(File file)
		throws IOException
	{
		
		defaultLocation = file.getParentFile();
		scanner = new Scanner(new BufferedReader(new FileReader(file)), false, this);		
		dtd = new DTD();
	}

	public DTDParser(File file, boolean flag)
		throws IOException
	{
		defaultLocation = file.getParentFile();
		scanner = new Scanner(new BufferedReader(new FileReader(file)), flag, this);
		dtd = new DTD();
	}

	public DTDParser(URL url)
		throws IOException
	{
		defaultLocation = url;
		scanner = new Scanner(new BufferedReader(new InputStreamReader(url.openStream())), false, this);
		dtd = new DTD();
	}

	public DTDParser(URL url, boolean flag)
		throws IOException
	{
		defaultLocation = url;
		scanner = new Scanner(new BufferedReader(new InputStreamReader(url.openStream())), flag, this);
		dtd = new DTD();
	}

	public DTD parse()
		throws IOException
	{
		return parse(false);
	}

	public DTD parse(boolean flag)
		throws IOException
	{
		do
		{
			Token token = scanner.peek();
			if(token.type == Scanner.EOF)
				break;
			parseTopLevelElement();
		} while(true);
		if(flag)
		{
			Hashtable hashtable = new Hashtable();
			DTDElement dtdelement;
			for(Enumeration enumeration = dtd.elements.elements(); enumeration.hasMoreElements(); hashtable.put(dtdelement.name, dtdelement))
				dtdelement = (DTDElement)enumeration.nextElement();

			for(Enumeration enumeration1 = dtd.elements.elements(); enumeration1.hasMoreElements();)
			{
				DTDElement dtdelement1 = (DTDElement)enumeration1.nextElement();
				if(dtdelement1.content instanceof DTDContainer)
				{
					for(Enumeration enumeration3 = ((DTDContainer)dtdelement1.content).getItemsVec().elements(); enumeration3.hasMoreElements(); removeElements(hashtable, dtd, (DTDItem)enumeration3.nextElement()));
				}
			}

			if(hashtable.size() == 1)
			{
				Enumeration enumeration2 = hashtable.elements();
				dtd.rootElement = (DTDElement)enumeration2.nextElement();
			} else
			{
				dtd.rootElement = null;
			}
		} else
		{
			dtd.rootElement = null;
		}
		return dtd;
	}

	protected void removeElements(Hashtable hashtable, DTD dtd1, DTDItem dtditem)
	{
		if(dtditem instanceof DTDName)
			hashtable.remove(((DTDName)dtditem).value);
		else
		if(dtditem instanceof DTDContainer)
		{
			for(Enumeration enumeration = ((DTDContainer)dtditem).getItemsVec().elements(); enumeration.hasMoreElements(); removeElements(hashtable, dtd1, (DTDItem)enumeration.nextElement()));
		}
	}

	protected void parseTopLevelElement()
		throws IOException
	{
		Token token = scanner.get();
		if(token.type == Scanner.LTQUES)
		{
			StringBuffer stringbuffer = new StringBuffer();
			do
			{
				String s = scanner.getUntil('?');
				stringbuffer.append(s);
				token = scanner.peek();
				if(token.type == Scanner.GT)
				{
					scanner.get();
					break;
				}
				stringbuffer.append('?');
			} while(true);
			DTDProcessingInstruction dtdprocessinginstruction = new DTDProcessingInstruction(stringbuffer.toString());
			dtd.items.addElement(dtdprocessinginstruction);
			return;
		}
		if(token.type == Scanner.CONDITIONAL)
		{
			token = expect(Scanner.IDENTIFIER);
			if(token.value.equals("IGNORE"))
				scanner.skipConditional();
			else
			if(token.value.equals("INCLUDE"))
				scanner.skipUntil('[');
			else
				throw new DTDParseException(scanner.getUriId(), "Invalid token in conditional: " + token.value, scanner.getLineNumber(), scanner.getColumn());
		} else
		if(token.type != Scanner.ENDCONDITIONAL)
			if(token.type == Scanner.COMMENT)
				dtd.items.addElement(new DTDComment(token.value));
			else
			if(token.type == Scanner.LTBANG)
			{
				Token token1 = expect(Scanner.IDENTIFIER);
				if(token1.value.equals("ELEMENT"))
					parseElement();
				else
				if(token1.value.equals("ATTLIST"))
					parseAttlist();
				else
				if(token1.value.equals("ENTITY"))
					parseEntity();
				else
				if(token1.value.equals("NOTATION"))
					parseNotation();
				else
					skipUntil(Scanner.GT);
			}
	}

	protected void skipUntil(TokenType tokentype)
		throws IOException
	{
		for(Token token = scanner.get(); token.type != tokentype; token = scanner.get());
	}

	protected Token expect(TokenType tokentype)
		throws IOException
	{
		Token token = scanner.get();
		if(token.type != tokentype)
		{
			if(token.value == null)
				throw new DTDParseException(scanner.getUriId(), "Expected " + tokentype.name + " instead of " + token.type.name, scanner.getLineNumber(), scanner.getColumn());
			else
				throw new DTDParseException(scanner.getUriId(), "Expected " + tokentype.name + " instead of " + token.type.name + "(" + token.value + ")", scanner.getLineNumber(), scanner.getColumn());
		} else
		{
			return token;
		}
	}

	protected void parseElement()
		throws IOException
	{
		Token token = expect(Scanner.IDENTIFIER);
		DTDElement dtdelement = (DTDElement)dtd.elements.get(token.value);
		if(dtdelement == null)
		{
			dtdelement = new DTDElement(token.value);
			dtd.elements.put(dtdelement.name, dtdelement);
		} else
		if(dtdelement.content != null)
			throw new DTDParseException(scanner.getUriId(), "Found second definition of element: " + token.value, scanner.getLineNumber(), scanner.getColumn());
		dtd.items.addElement(dtdelement);
		parseContentSpec(scanner, dtdelement);
		expect(Scanner.GT);
	}

	protected void parseContentSpec(Scanner scanner1, DTDElement dtdelement)
		throws IOException
	{
		Token token = scanner1.get();
		if(token.type == Scanner.IDENTIFIER)
		{
			if(token.value.equals("EMPTY"))
				dtdelement.content = new DTDEmpty();
			else
			if(token.value.equals("ANY"))
				dtdelement.content = new DTDAny();
			else
				throw new DTDParseException(scanner1.getUriId(), "Invalid token in entity content spec " + token.value, scanner1.getLineNumber(), scanner1.getColumn());
		} else
		if(token.type == Scanner.LPAREN)
		{
			Token token1 = scanner1.peek();
			if(token1.type == Scanner.IDENTIFIER)
			{
				if(token1.value.equals("#PCDATA"))
					parseMixed(dtdelement);
				else
					parseChildren(dtdelement);
			} else
			if(token1.type == Scanner.LPAREN)
				parseChildren(dtdelement);
		}
	}

	protected void parseMixed(DTDElement dtdelement)
		throws IOException
	{
		DTDMixed dtdmixed = new DTDMixed();
		dtdmixed.add(new DTDPCData());
		scanner.get();
		dtdelement.content = dtdmixed;
		do
		{
			Token token = scanner.get();
			if(token.type == Scanner.RPAREN)
			{
				token = scanner.peek();
				if(token.type == Scanner.ASTERISK)
				{
					scanner.get();
					dtdmixed.cardinal = DTDCardinal.ZEROMANY;
				} else
				{
					dtdmixed.cardinal = DTDCardinal.NONE;
				}
				return;
			}
			if(token.type == Scanner.PIPE)
			{
				token = scanner.get();
				dtdmixed.add(new DTDName(token.value));
			} else
			{
				throw new DTDParseException(scanner.getUriId(), "Invalid token in Mixed content type: " + token.type.name, scanner.getLineNumber(), scanner.getColumn());
			}
		} while(true);
	}

	protected void parseChildren(DTDElement dtdelement)
		throws IOException
	{
		DTDContainer dtdcontainer = parseChoiceSequence();
		Token token = scanner.peek();
		dtdcontainer.cardinal = parseCardinality();
		if(token.type == Scanner.QUES)
			dtdcontainer.cardinal = DTDCardinal.OPTIONAL;
		else
		if(token.type == Scanner.ASTERISK)
			dtdcontainer.cardinal = DTDCardinal.ZEROMANY;
		else
		if(token.type == Scanner.PLUS)
			dtdcontainer.cardinal = DTDCardinal.ONEMANY;
		else
			dtdcontainer.cardinal = DTDCardinal.NONE;
		dtdelement.content = dtdcontainer;
	}

	protected DTDContainer parseChoiceSequence()
		throws IOException
	{
		TokenType tokentype = null;
		Object obj = null;
		DTDItem dtditem;
		Token token;
		do
		{
			dtditem = parseCP();
			token = scanner.get();
			if(token.type != Scanner.PIPE && token.type != Scanner.COMMA)
				break;
			if(tokentype != null && tokentype != token.type)
				throw new DTDParseException(scanner.getUriId(), "Can't mix separators in a choice/sequence", scanner.getLineNumber(), scanner.getColumn());
			tokentype = token.type;
			if(obj == null)
				if(token.type == Scanner.PIPE)
					obj = new DTDChoice();
				else
					obj = new DTDSequence();
			((DTDContainer) (obj)).add(dtditem);
		} while(true);
		if(token.type == Scanner.RPAREN)
		{
			if(obj == null)
				obj = new DTDChoice();
			((DTDContainer) (obj)).add(dtditem);
			return ((DTDContainer) (obj));
		} else
		{
			throw new DTDParseException(scanner.getUriId(), "Found invalid token in sequence: " + token.type.name, scanner.getLineNumber(), scanner.getColumn());
		}
	}

	protected DTDItem parseCP()
		throws IOException
	{
		Token token = scanner.get();
		Object obj = null;
		if(token.type == Scanner.IDENTIFIER)
			obj = new DTDName(token.value);
		else
		if(token.type == Scanner.LPAREN)
			obj = parseChoiceSequence();
		else
			throw new DTDParseException(scanner.getUriId(), "Found invalid token in sequence: " + token.type.name, scanner.getLineNumber(), scanner.getColumn());
		
		((DTDItem)obj).cardinal = parseCardinality();
		return ((DTDItem) (obj));
	}

	protected DTDCardinal parseCardinality()
		throws IOException
	{
		Token token = scanner.peek();
		if(token.type == Scanner.QUES)
		{
			scanner.get();
			return DTDCardinal.OPTIONAL;
		}
		if(token.type == Scanner.ASTERISK)
		{
			scanner.get();
			return DTDCardinal.ZEROMANY;
		}
		if(token.type == Scanner.PLUS)
		{
			scanner.get();
			return DTDCardinal.ONEMANY;
		} else
		{
			return DTDCardinal.NONE;
		}
	}

	protected void parseAttlist()
		throws IOException
	{
		Token token = expect(Scanner.IDENTIFIER);
		DTDElement dtdelement = (DTDElement)dtd.elements.get(token.value);
		DTDAttlist dtdattlist = new DTDAttlist(token.value);
		dtd.items.addElement(dtdattlist);
		if(dtdelement == null)
		{
			dtdelement = new DTDElement(token.value);
			dtd.elements.put(token.value, dtdelement);
		}
		for(Token token1 = scanner.peek(); token1.type != Scanner.GT; token1 = scanner.peek())
			parseAttdef(scanner, dtdelement, dtdattlist);

	}

	protected void parseAttdef(Scanner scanner1, DTDElement dtdelement, DTDAttlist dtdattlist)
		throws IOException
	{
		Token token = expect(Scanner.IDENTIFIER);
		DTDAttribute dtdattribute = new DTDAttribute(token.value);
		dtdattlist.attributes.addElement(dtdattribute);
		dtdelement.attributes.put(token.value, dtdattribute);
		token = scanner1.get();
		if(token.type == Scanner.IDENTIFIER)
		{
			if(token.value.equals("NOTATION"))
				dtdattribute.type = parseNotationList();
			else
				dtdattribute.type = token.value;
		} else
		if(token.type == Scanner.LPAREN)
			dtdattribute.type = parseEnumeration();
		token = scanner1.peek();
		if(token.type == Scanner.IDENTIFIER)
		{
			scanner1.get();
			if(token.value.equals("#FIXED"))
			{
				dtdattribute.decl = DTDDecl.FIXED;
				token = scanner1.get();
				dtdattribute.defaultValue = token.value;
			} else
			if(token.value.equals("#REQUIRED"))
				dtdattribute.decl = DTDDecl.REQUIRED;
			else
			if(token.value.equals("#IMPLIED"))
				dtdattribute.decl = DTDDecl.IMPLIED;
			else
				throw new DTDParseException(scanner1.getUriId(), "Invalid token in attribute declaration: " + token.value, scanner1.getLineNumber(), scanner1.getColumn());
		} else
		if(token.type == Scanner.STRING)
		{
			scanner1.get();
			dtdattribute.decl = DTDDecl.VALUE;
			dtdattribute.defaultValue = token.value;
		}
	}

	protected DTDNotationList parseNotationList()
		throws IOException
	{
		DTDNotationList dtdnotationlist = new DTDNotationList();
		do
		{
			Token token = scanner.get();
			if(token.type != Scanner.IDENTIFIER)
				throw new DTDParseException(scanner.getUriId(), "Invalid token in notation: " + token.type.name, scanner.getLineNumber(), scanner.getColumn());
			dtdnotationlist.add(token.value);
			token = scanner.peek();
			if(token.type == Scanner.RPAREN)
			{
				scanner.get();
				return dtdnotationlist;
			}
			if(token.type != Scanner.PIPE)
				throw new DTDParseException(scanner.getUriId(), "Invalid token in notation: " + token.type.name, scanner.getLineNumber(), scanner.getColumn());
			scanner.get();
		} while(true);
	}

	protected DTDEnumeration parseEnumeration()
		throws IOException
	{
		DTDEnumeration dtdenumeration = new DTDEnumeration();
		do
		{
			Token token = scanner.get();
			if(token.type != Scanner.IDENTIFIER && token.type != Scanner.NMTOKEN)
				throw new DTDParseException(scanner.getUriId(), "Invalid token in enumeration: " + token.type.name, scanner.getLineNumber(), scanner.getColumn());
			dtdenumeration.add(token.value);
			token = scanner.peek();
			if(token.type == Scanner.RPAREN)
			{
				scanner.get();
				return dtdenumeration;
			}
			if(token.type != Scanner.PIPE)
				throw new DTDParseException(scanner.getUriId(), "Invalid token in enumeration: " + token.type.name, scanner.getLineNumber(), scanner.getColumn());
			scanner.get();
		} while(true);
	}

	protected void parseEntity()
		throws IOException
	{
		boolean flag = false;
		Token token = scanner.get();
		if(token.type == Scanner.PERCENT)
		{
			flag = true;
			token = expect(Scanner.IDENTIFIER);
		} else
		if(token.type != Scanner.IDENTIFIER)
			throw new DTDParseException(scanner.getUriId(), "Invalid entity declaration", scanner.getLineNumber(), scanner.getColumn());
		DTDEntity dtdentity = (DTDEntity)dtd.entities.get(token.value);
		boolean flag1 = false;
		if(dtdentity == null)
		{
			dtdentity = new DTDEntity(token.value, defaultLocation);
			dtd.entities.put(dtdentity.name, dtdentity);
		} else
		{
			dtdentity = new DTDEntity(token.value, defaultLocation);
			flag1 = true;
		}
		dtd.items.addElement(dtdentity);
		dtdentity.isParsed = flag;
		parseEntityDef(dtdentity);
		if(dtdentity.isParsed && dtdentity.value != null && !flag1)
			scanner.addEntity(dtdentity.name, dtdentity.value);
	}

	protected void parseEntityDef(DTDEntity dtdentity)
		throws IOException
	{
		Token token = scanner.get();
		if(token.type == Scanner.STRING)
			dtdentity.value = token.value;
		else
		if(token.type == Scanner.IDENTIFIER)
		{
			if(token.value.equals("SYSTEM"))
			{
				DTDSystem dtdsystem = new DTDSystem();
				token = expect(Scanner.STRING);
				dtdsystem.system = token.value;
				dtdentity.externalID = dtdsystem;
			} else
			if(token.value.equals("PUBLIC"))
			{
				DTDPublic dtdpublic = new DTDPublic();
				Token token1 = expect(Scanner.STRING);
				dtdpublic.pub = token1.value;
				token1 = expect(Scanner.STRING);
				dtdpublic.system = token1.value;
				dtdentity.externalID = dtdpublic;
			} else
			{
				throw new DTDParseException(scanner.getUriId(), "Invalid External ID specification", scanner.getLineNumber(), scanner.getColumn());
			}
			if(!dtdentity.isParsed)
			{
				Token token2 = scanner.peek();
				if(token2.type == Scanner.IDENTIFIER)
				{
					if(!token2.value.equals("NDATA"))
						throw new DTDParseException(scanner.getUriId(), "Invalid NData declaration", scanner.getLineNumber(), scanner.getColumn());
					token2 = scanner.get();
					token2 = expect(Scanner.IDENTIFIER);
					dtdentity.ndata = token2.value;
				}
			}
		} else
		{
			throw new DTDParseException(scanner.getUriId(), "Invalid entity definition", scanner.getLineNumber(), scanner.getColumn());
		}
		expect(Scanner.GT);
	}

	protected void parseNotation()
		throws IOException
	{
		DTDNotation dtdnotation = new DTDNotation();
		Token token = expect(Scanner.IDENTIFIER);
		dtdnotation.name = token.value;
		dtd.notations.put(dtdnotation.name, dtdnotation);
		dtd.items.addElement(dtdnotation);
		token = expect(Scanner.IDENTIFIER);
		if(token.value.equals("SYSTEM"))
		{
			DTDSystem dtdsystem = new DTDSystem();
			token = expect(Scanner.STRING);
			dtdsystem.system = token.value;
			dtdnotation.externalID = dtdsystem;
		} else
		if(token.value.equals("PUBLIC"))
		{
			DTDPublic dtdpublic = new DTDPublic();
			Token token1 = expect(Scanner.STRING);
			dtdpublic.pub = token1.value;
			dtdpublic.system = null;
			token1 = scanner.peek();
			if(token1.type == Scanner.STRING)
			{
				Token token2 = scanner.get();
				dtdpublic.system = token2.value;
			}
			dtdnotation.externalID = dtdpublic;
		}
		expect(Scanner.GT);
	}

	public DTDEntity expandEntity(String s)
	{
		return (DTDEntity)dtd.entities.get(s);
	}

	protected Scanner scanner;
	protected DTD dtd;
	protected Object defaultLocation;
}