// Decompiled by DJ v2.9.9.61 Copyright 2000 Atanas Neshkov  Date: 31/03/2004 10:57:58
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   Scanner.java

package com.wutka.dtd;

import java.io.*;
import java.util.Hashtable;
import java.util.Stack;

// Referenced classes of package com.wutka.dtd:
//			  Token, DTDParseException, TokenType, EntityExpansion, 
//			  DTDEntity

class Scanner
{
	protected class StreamInfo
	{

		String id;
		Reader in;
		int lineNumber;
		int column;

		StreamInfo(String s, Reader reader)
		{
			lineNumber 	= 1;
			column 		= 1;
			id 			= s;
			in 			= reader;
		}
	}


	public Scanner(Reader reader, EntityExpansion entityexpansion)
	{
		
		this(reader, false, entityexpansion);
		
	}

	public Scanner(Reader reader, boolean flag, EntityExpansion entityexpansion)
	{
		in 		= new StreamInfo("", reader);
		atEOF 	= false;
		trace 	= flag;
		expandBuffer 	= null;
		entityExpansion = new Hashtable();
		expander 		= entityexpansion;
	}

	public Token peek()
		throws IOException
	{
		if(nextToken == null)
			nextToken = readNextToken();
		return nextToken;
	}

	public Token get()
		throws IOException
	{
		if(nextToken == null)
			nextToken = readNextToken();
		Token token = nextToken;
		nextToken = null;
		return token;
	}

	protected int readNextChar()
		throws IOException
	{
		int i = in.in.read();
		if(i < 0 && inputStreams != null && !inputStreams.empty())
		{
			in.in.close();
			in = (StreamInfo)inputStreams.pop();
			return readNextChar();
		} else
		{
			return i;
		}
	}

	protected int peekChar()
		throws IOException
	{
		if(expandBuffer != null)
			return expandBuffer[expandPos];
		if(nextChar == 0)
		{
			nextChar = readNextChar();
			in.column++;
			if(nextChar == 10)
			{
				in.lineNumber++;
				in.column = 1;
			}
		}
		return nextChar;
	}

	protected int read()
		throws IOException
	{
		if(expandBuffer != null)
		{
			int i = expandBuffer[expandPos++];
			if(expandPos >= expandBuffer.length)
			{
				expandPos = -1;
				expandBuffer = null;
			}
			if(trace)
				System.out.print((char)i);
			return i;
		}
		if(nextChar == 0)
			peekChar();
		int j = nextChar;
		nextChar = 0;
		if(trace)
			System.out.print((char)j);
		return j;
	}

	public String getUntil(char c)
		throws IOException
	{
		StringBuffer stringbuffer = new StringBuffer();
		int i;
		while((i = read()) >= 0) 
		{
			if(i == c)
				return stringbuffer.toString();
			stringbuffer.append((char)i);
		}
		return stringbuffer.toString();
	}

	public void skipUntil(char c)
		throws IOException
	{
		int i;
		while((i = read()) >= 0) 
			if(i == c)
				return;
	}

	protected Token readNextToken()
		throws IOException
	{
		int i;
		do
		{
			do
			{
				i = read();
				if(i == 60)
				{
					i = peekChar();
					if(i == 33)
					{
						read();
						if(peekChar() == 91)
						{
							read();
							return new Token(CONDITIONAL);
						}
						if(peekChar() != 45)
							return new Token(LTBANG);
						read();
						if(peekChar() != 45)
							throw new DTDParseException(getUriId(), "Invalid character sequence <!-" + read(), getLineNumber(), getColumn());
						read();
						StringBuffer stringbuffer = new StringBuffer();
						do
						{
							if(peekChar() < 0)
								throw new DTDParseException(getUriId(), "Unterminated comment: <!--" + stringbuffer.toString(), getLineNumber(), getColumn());
							if(peekChar() != 45)
							{
								stringbuffer.append((char)read());
							} else
							{
								read();
								if(peekChar() < 0)
									throw new DTDParseException(getUriId(), "Unterminated comment: <!--" + stringbuffer.toString(), getLineNumber(), getColumn());
								if(peekChar() == 45)
								{
									read();
									if(peekChar() != 62)
									{
										throw new DTDParseException(getUriId(), "Invalid character sequence --" + read(), getLineNumber(), getColumn());
									} else
									{
										read();
										return new Token(COMMENT, stringbuffer.toString());
									}
								}
								stringbuffer.append('-');
							}
						} while(true);
					}
					if(i == 63)
					{
						read();
						return new Token(LTQUES);
					} else
					{
						return new Token(LT);
					}
				}
				if(i == 63)
					return new Token(QUES);
				if(i == 34 || i == 39)
				{
					int j = i;
					StringBuffer stringbuffer4 = new StringBuffer();
					while(peekChar() != j) 
					{
						i = read();
						if(i == 92)
							stringbuffer4.append((char)read());
						else
							stringbuffer4.append((char)i);
					}
					read();
					return new Token(STRING, stringbuffer4.toString());
				}
				if(i == 40)
					return new Token(LPAREN);
				if(i == 41)
					return new Token(RPAREN);
				if(i == 124)
					return new Token(PIPE);
				if(i == 62)
					return new Token(GT);
				if(i == 61)
					return new Token(EQUAL);
				if(i == 42)
					return new Token(ASTERISK);
				if(i == 93)
				{
					if(read() != 93)
						throw new DTDParseException(getUriId(), "Illegal character in input stream: " + i, getLineNumber(), getColumn());
					if(read() != 62)
						throw new DTDParseException(getUriId(), "Illegal character in input stream: " + i, getLineNumber(), getColumn());
					else
						return new Token(ENDCONDITIONAL);
				}
				if(i == 35)
				{
					StringBuffer stringbuffer1 = new StringBuffer();
					stringbuffer1.append((char)i);
					for(; isIdentifierChar((char)peekChar()); stringbuffer1.append((char)read()));
					return new Token(IDENTIFIER, stringbuffer1.toString());
				}
				if(i != 38 && i != 37)
					break;
				if(i == 37 && Character.isWhitespace((char)peekChar()))
					return new Token(PERCENT);
				boolean flag = i == 37;
				StringBuffer stringbuffer5 = new StringBuffer();
				stringbuffer5.append((char)i);
				for(; isIdentifierChar((char)peekChar()); stringbuffer5.append((char)read()));
				if(read() != 59)
					throw new DTDParseException(getUriId(), "Expected ';' after reference " + stringbuffer5.toString() + ", found '" + i + "'", getLineNumber(), getColumn());
				stringbuffer5.append(';');
				if(!flag || !expandEntity(stringbuffer5.toString()))
					return new Token(IDENTIFIER, stringbuffer5.toString());
			} while(true);
			if(i == 43)
				return new Token(PLUS);
			if(i == 44)
				return new Token(COMMA);
			if(isLetter((char)i))
			{
				StringBuffer stringbuffer2 = new StringBuffer();
				stringbuffer2.append((char)i);
				for(; isIdentifierChar((char)peekChar()); stringbuffer2.append((char)read()));
				return new Token(IDENTIFIER, stringbuffer2.toString());
			}
			if(isIdentifierChar((char)i))
			{
				StringBuffer stringbuffer3 = new StringBuffer();
				stringbuffer3.append((char)i);
				for(; isIdentifierChar((char)peekChar()); stringbuffer3.append((char)read()));
				return new Token(NMTOKEN, stringbuffer3.toString());
			}
			if(i < 0)
				if(atEOF)
				{
					throw new IOException("Read past EOF");
				} else
				{
					atEOF = true;
					return new Token(EOF);
				}
		} while(Character.isWhitespace((char)i));
		throw new DTDParseException(getUriId(), "Illegal character in input stream: " + i, getLineNumber(), getColumn());
	}

	public void skipConditional()
		throws IOException
	{
		int i = 0;
		int j = 0;
		do
		{
			if(i != 93)
				i = read();
			if(i == 93)
			{
				i = read();
				if(i == 93)
				{
					i = read();
					if(i == 62)
					{
						if(j == 0)
							break;
						j--;
					}
				}
			}
			if(i == 60)
			{
				i = read();
				if(i == 33)
				{
					i = read();
					if(i == 91)
						j++;
				}
			}
		} while(true);
	}

	public String getUriId()
	{
		return in.id;
	}

	public int getLineNumber()
	{
		return in.lineNumber;
	}

	public int getColumn()
	{
		return in.column;
	}

	public boolean isIdentifierChar(char c)
	{
		return isLetter(c) || isDigit(c) || c == '-' || c == '_' || c == '.' || c == ':' || isCombiningChar(c) || isExtender(c);
	}

	public boolean isLetter(char c)
	{
		return isBaseChar(c) || isIdeographic(c);
	}

	public boolean isBaseChar(char c)
	{
		for(int i = 0; i < letterRanges.length; i++)
		{
			if(c < letterRanges[i][0])
				return false;
			if(c >= letterRanges[i][0] && c <= letterRanges[i][1])
				return true;
		}

		return false;
	}

	public boolean isIdeographic(char c)
	{
		if(c < '\u4E00')
			return false;
		if(c >= '\u4E00' && c <= '\u9FA5')
			return true;
		if(c == '\u3007')
			return true;
		return c >= '\u3021' && c <= '\u3029';
	}

	public boolean isDigit(char c)
	{
		if(c >= '0' && c <= '9')
			return true;
		if(c < '\u0660')
			return false;
		if(c >= '\u0660' && c <= '\u0669')
			return true;
		if(c < '\u06F0')
			return false;
		if(c >= '\u06F0' && c <= '\u06F9')
			return true;
		if(c < '\u0966')
			return false;
		if(c >= '\u0966' && c <= '\u096F')
			return true;
		if(c < '\u09E6')
			return false;
		if(c >= '\u09E6' && c <= '\u09EF')
			return true;
		if(c < '\u0A66')
			return false;
		if(c >= '\u0A66' && c <= '\u0A6F')
			return true;
		if(c < '\u0AE6')
			return false;
		if(c >= '\u0AE6' && c <= '\u0AEF')
			return true;
		if(c < '\u0B66')
			return false;
		if(c >= '\u0B66' && c <= '\u0B6F')
			return true;
		if(c < '\u0BE7')
			return false;
		if(c >= '\u0BE7' && c <= '\u0BEF')
			return true;
		if(c < '\u0C66')
			return false;
		if(c >= '\u0C66' && c <= '\u0C6F')
			return true;
		if(c < '\u0CE6')
			return false;
		if(c >= '\u0CE6' && c <= '\u0CEF')
			return true;
		if(c < '\u0D66')
			return false;
		if(c >= '\u0D66' && c <= '\u0D6F')
			return true;
		if(c < '\u0E50')
			return false;
		if(c >= '\u0E50' && c <= '\u0E59')
			return true;
		if(c < '\u0ED0')
			return false;
		if(c >= '\u0ED0' && c <= '\u0ED9')
			return true;
		if(c < '\u0F20')
			return false;
		return c >= '\u0F20' && c <= '\u0F29';
	}

	public boolean isCombiningChar(char c)
	{
		if(c < '\u0300')
			return false;
		if(c >= '\u0300' && c <= '\u0345')
			return true;
		if(c >= '\u0360' && c <= '\u0361')
			return true;
		if(c >= '\u0483' && c <= '\u0486')
			return true;
		if(c >= '\u0591' && c <= '\u05A1')
			return true;
		if(c >= '\u05A3' && c <= '\u05B9')
			return true;
		if(c >= '\u05BB' && c <= '\u05BD')
			return true;
		if(c == '\u05BF')
			return true;
		if(c >= '\u05C1' && c <= '\u05C2')
			return true;
		if(c == '\u05C4')
			return true;
		if(c >= '\u064B' && c <= '\u0652')
			return true;
		if(c == '\u0670')
			return true;
		if(c >= '\u06D6' && c <= '\u06DC')
			return true;
		if(c >= '\u06DD' && c <= '\u06DF')
			return true;
		if(c >= '\u06E0' && c <= '\u06E4')
			return true;
		if(c >= '\u06E7' && c <= '\u06E8')
			return true;
		if(c >= '\u06EA' && c <= '\u06ED')
			return true;
		if(c >= '\u0901' && c <= '\u0903')
			return true;
		if(c == '\u093C')
			return true;
		if(c >= '\u093E' && c <= '\u094C')
			return true;
		if(c == '\u094D')
			return true;
		if(c >= '\u0951' && c <= '\u0954')
			return true;
		if(c >= '\u0962' && c <= '\u0963')
			return true;
		if(c >= '\u0981' && c <= '\u0983')
			return true;
		if(c == '\u09BC')
			return true;
		if(c == '\u09BE')
			return true;
		if(c == '\u09BF')
			return true;
		if(c >= '\u09C0' && c <= '\u09C4')
			return true;
		if(c >= '\u09C7' && c <= '\u09C8')
			return true;
		if(c >= '\u09CB' && c <= '\u09CD')
			return true;
		if(c == '\u09D7')
			return true;
		if(c >= '\u09E2' && c <= '\u09E3')
			return true;
		if(c == '\u0A02')
			return true;
		if(c == '\u0A3C')
			return true;
		if(c == '\u0A3E')
			return true;
		if(c == '\u0A3F')
			return true;
		if(c >= '\u0A40' && c <= '\u0A42')
			return true;
		if(c >= '\u0A47' && c <= '\u0A48')
			return true;
		if(c >= '\u0A4B' && c <= '\u0A4D')
			return true;
		if(c >= '\u0A70' && c <= '\u0A71')
			return true;
		if(c >= '\u0A81' && c <= '\u0A83')
			return true;
		if(c == '\u0ABC')
			return true;
		if(c >= '\u0ABE' && c <= '\u0AC5')
			return true;
		if(c >= '\u0AC7' && c <= '\u0AC9')
			return true;
		if(c >= '\u0ACB' && c <= '\u0ACD')
			return true;
		if(c >= '\u0B01' && c <= '\u0B03')
			return true;
		if(c == '\u0B3C')
			return true;
		if(c >= '\u0B3E' && c <= '\u0B43')
			return true;
		if(c >= '\u0B47' && c <= '\u0B48')
			return true;
		if(c >= '\u0B4B' && c <= '\u0B4D')
			return true;
		if(c >= '\u0B56' && c <= '\u0B57')
			return true;
		if(c >= '\u0B82' && c <= '\u0B83')
			return true;
		if(c >= '\u0BBE' && c <= '\u0BC2')
			return true;
		if(c >= '\u0BC6' && c <= '\u0BC8')
			return true;
		if(c >= '\u0BCA' && c <= '\u0BCD')
			return true;
		if(c == '\u0BD7')
			return true;
		if(c >= '\u0C01' && c <= '\u0C03')
			return true;
		if(c >= '\u0C3E' && c <= '\u0C44')
			return true;
		if(c >= '\u0C46' && c <= '\u0C48')
			return true;
		if(c >= '\u0C4A' && c <= '\u0C4D')
			return true;
		if(c >= '\u0C55' && c <= '\u0C56')
			return true;
		if(c >= '\u0C82' && c <= '\u0C83')
			return true;
		if(c >= '\u0CBE' && c <= '\u0CC4')
			return true;
		if(c >= '\u0CC6' && c <= '\u0CC8')
			return true;
		if(c >= '\u0CCA' && c <= '\u0CCD')
			return true;
		if(c >= '\u0CD5' && c <= '\u0CD6')
			return true;
		if(c >= '\u0D02' && c <= '\u0D03')
			return true;
		if(c >= '\u0D3E' && c <= '\u0D43')
			return true;
		if(c >= '\u0D46' && c <= '\u0D48')
			return true;
		if(c >= '\u0D4A' && c <= '\u0D4D')
			return true;
		if(c == '\u0D57')
			return true;
		if(c == '\u0E31')
			return true;
		if(c >= '\u0E34' && c <= '\u0E3A')
			return true;
		if(c >= '\u0E47' && c <= '\u0E4E')
			return true;
		if(c == '\u0EB1')
			return true;
		if(c >= '\u0EB4' && c <= '\u0EB9')
			return true;
		if(c >= '\u0EBB' && c <= '\u0EBC')
			return true;
		if(c >= '\u0EC8' && c <= '\u0ECD')
			return true;
		if(c >= '\u0F18' && c <= '\u0F19')
			return true;
		if(c == '\u0F35')
			return true;
		if(c == '\u0F37')
			return true;
		if(c == '\u0F39')
			return true;
		if(c == '\u0F3E')
			return true;
		if(c == '\u0F3F')
			return true;
		if(c >= '\u0F71' && c <= '\u0F84')
			return true;
		if(c >= '\u0F86' && c <= '\u0F8B')
			return true;
		if(c >= '\u0F90' && c <= '\u0F95')
			return true;
		if(c == '\u0F97')
			return true;
		if(c >= '\u0F99' && c <= '\u0FAD')
			return true;
		if(c >= '\u0FB1' && c <= '\u0FB7')
			return true;
		if(c == '\u0FB9')
			return true;
		if(c >= '\u20D0' && c <= '\u20DC')
			return true;
		if(c == '\u20E1')
			return true;
		if(c >= '\u302A' && c <= '\u302F')
			return true;
		if(c == '\u3099')
			return true;
		return c == '\u309A';
	}

	public boolean isExtender(char c)
	{
		if(c < '\267')
			return false;
		return c == '\267' || c == '\u02D0' || c == '\u02D1' || c == '\u0387' || c == '\u0640' || c == '\u0E46' || c >= '\u3031' && c <= '\u3035' || c >= '\u309D' && c <= '\u309E' || c >= '\u30FC' && c <= '\u30FE';
	}

	public boolean expandEntity(String s)
		throws IOException
	{
		String s1 = (String)entityExpansion.get(s);
		if(s1 != null)
		{
			expand(s1.toCharArray());
			return true;
		}
		s = s.substring(1, s.length() - 1);
		DTDEntity dtdentity = expander.expandEntity(s);
		if(dtdentity != null)
		{
			Reader reader = dtdentity.getReader();
			if(reader != null)
			{
				if(inputStreams == null)
					inputStreams = new Stack();
				inputStreams.push(in);
				in = new StreamInfo(dtdentity.getExternalId(), reader);
				return true;
			}
		}
		return false;
	}

	public void expand(char ac[])
	{
		if(expandBuffer != null)
		{
			int i = expandBuffer.length - expandPos;
			char ac1[] = new char[i + ac.length];
			System.arraycopy(ac, 0, ac1, 0, ac.length);
			System.arraycopy(expandBuffer, expandPos, ac1, ac.length, i);
			expandPos = 0;
			expandBuffer = ac1;
			if(expandBuffer.length == 0)
			{
				expandBuffer = null;
				expandPos = -1;
			}
		} else
		{
			expandBuffer = ac;
			expandPos = 0;
			if(expandBuffer.length == 0)
			{
				expandBuffer = null;
				expandPos = -1;
			}
		}
	}

	public void addEntity(String s, String s1)
	{
		entityExpansion.put("%" + s + ";", s1);
	}

	public static final TokenType LTQUES = new TokenType(0, "LTQUES");
	public static final TokenType IDENTIFIER = new TokenType(1, "IDENTIFIER");
	public static final TokenType EQUAL = new TokenType(2, "EQUAL");
	public static final TokenType LPAREN = new TokenType(3, "LPAREN");
	public static final TokenType RPAREN = new TokenType(4, "RPAREN");
	public static final TokenType COMMA = new TokenType(5, "COMMA");
	public static final TokenType STRING = new TokenType(6, "STRING");
	public static final TokenType QUESGT = new TokenType(7, "QUESGT");
	public static final TokenType LTBANG = new TokenType(8, "LTBANG");
	public static final TokenType GT = new TokenType(9, "GT");
	public static final TokenType PIPE = new TokenType(10, "PIPE");
	public static final TokenType QUES = new TokenType(11, "QUES");
	public static final TokenType PLUS = new TokenType(12, "PLUS");
	public static final TokenType ASTERISK = new TokenType(13, "ASTERISK");
	public static final TokenType LT = new TokenType(14, "LT");
	public static final TokenType EOF = new TokenType(15, "EOF");
	public static final TokenType COMMENT = new TokenType(16, "COMMENT");
	public static final TokenType PERCENT = new TokenType(17, "PERCENT");
	public static final TokenType CONDITIONAL = new TokenType(18, "CONDITIONAL");
	public static final TokenType ENDCONDITIONAL = new TokenType(19, "ENDCONDITIONAL");
	public static final TokenType NMTOKEN = new TokenType(20, "NMTOKEN");
	protected StreamInfo in;
	protected Stack inputStreams;
	protected Token nextToken;
	protected int nextChar;
	protected boolean atEOF;
	protected boolean trace;
	protected char expandBuffer[];
	protected int expandPos;
	protected Hashtable entityExpansion;
	protected EntityExpansion expander;
	public static char letterRanges[][] = {
		{
			'A', 'Z'
		}, {
			'a', 'z'
		}, {
			'\300', '\326'
		}, {
			'\330', '\366'
		}, {
			'\370', '\377'
		}, {
			'\u0100', '\u0131'
		}, {
			'\u0134', '\u013E'
		}, {
			'\u0141', '\u0148'
		}, {
			'\u014A', '\u017E'
		}, {
			'\u0180', '\u01C3'
		}, {
			'\u01CD', '\u01F0'
		}, {
			'\u01F4', '\u01F5'
		}, {
			'\u01FA', '\u0217'
		}, {
			'\u0250', '\u02A8'
		}, {
			'\u02BB', '\u02C1'
		}, {
			'\u0386', '\u0386'
		}, {
			'\u0388', '\u038A'
		}, {
			'\u038C', '\u038C'
		}, {
			'\u038E', '\u03A1'
		}, {
			'\u03A3', '\u03CE'
		}, {
			'\u03D0', '\u03D6'
		}, {
			'\u03DA', '\u03DA'
		}, {
			'\u03DC', '\u03DC'
		}, {
			'\u03DE', '\u03DE'
		}, {
			'\u03E0', '\u03E0'
		}, {
			'\u03E2', '\u03F3'
		}, {
			'\u0401', '\u040C'
		}, {
			'\u040E', '\u044F'
		}, {
			'\u0451', '\u045C'
		}, {
			'\u045E', '\u0481'
		}, {
			'\u0490', '\u04C4'
		}, {
			'\u04C7', '\u04C8'
		}, {
			'\u04CB', '\u04CC'
		}, {
			'\u04D0', '\u04EB'
		}, {
			'\u04EE', '\u04F5'
		}, {
			'\u04F8', '\u04F9'
		}, {
			'\u0531', '\u0556'
		}, {
			'\u0559', '\u0559'
		}, {
			'\u0561', '\u0586'
		}, {
			'\u05D0', '\u05EA'
		}, {
			'\u05F0', '\u05F2'
		}, {
			'\u0621', '\u063A'
		}, {
			'\u0641', '\u064A'
		}, {
			'\u0671', '\u06B7'
		}, {
			'\u06BA', '\u06BE'
		}, {
			'\u06C0', '\u06CE'
		}, {
			'\u06D0', '\u06D3'
		}, {
			'\u06D5', '\u06D5'
		}, {
			'\u06E5', '\u06E6'
		}, {
			'\u0905', '\u0939'
		}, {
			'\u093D', '\u093D'
		}, {
			'\u0958', '\u0961'
		}, {
			'\u0985', '\u098C'
		}, {
			'\u098F', '\u0990'
		}, {
			'\u0993', '\u09A8'
		}, {
			'\u09AA', '\u09B0'
		}, {
			'\u09B2', '\u09B2'
		}, {
			'\u09B6', '\u09B9'
		}, {
			'\u09DC', '\u09DD'
		}, {
			'\u09DF', '\u09E1'
		}, {
			'\u09F0', '\u09F1'
		}, {
			'\u0A05', '\u0A0A'
		}, {
			'\u0A0F', '\u0A10'
		}, {
			'\u0A13', '\u0A28'
		}, {
			'\u0A2A', '\u0A30'
		}, {
			'\u0A32', '\u0A33'
		}, {
			'\u0A35', '\u0A36'
		}, {
			'\u0A38', '\u0A39'
		}, {
			'\u0A59', '\u0A5C'
		}, {
			'\u0A5E', '\u0A5E'
		}, {
			'\u0A72', '\u0A74'
		}, {
			'\u0A85', '\u0A8B'
		}, {
			'\u0A8D', '\u0A8D'
		}, {
			'\u0A8F', '\u0A91'
		}, {
			'\u0A93', '\u0AA8'
		}, {
			'\u0AAA', '\u0AB0'
		}, {
			'\u0AB2', '\u0AB3'
		}, {
			'\u0AB5', '\u0AB9'
		}, {
			'\u0ABD', '\u0ABD'
		}, {
			'\u0AE0', '\u0AE0'
		}, {
			'\u0B05', '\u0B0C'
		}, {
			'\u0B0F', '\u0B10'
		}, {
			'\u0B13', '\u0B28'
		}, {
			'\u0B2A', '\u0B30'
		}, {
			'\u0B32', '\u0B33'
		}, {
			'\u0B36', '\u0B39'
		}, {
			'\u0B3D', '\u0B3D'
		}, {
			'\u0B5C', '\u0B5D'
		}, {
			'\u0B5F', '\u0B61'
		}, {
			'\u0B85', '\u0B8A'
		}, {
			'\u0B8E', '\u0B90'
		}, {
			'\u0B92', '\u0B95'
		}, {
			'\u0B99', '\u0B9A'
		}, {
			'\u0B9C', '\u0B9C'
		}, {
			'\u0B9E', '\u0B9F'
		}, {
			'\u0BA3', '\u0BA4'
		}, {
			'\u0BA8', '\u0BAA'
		}, {
			'\u0BAE', '\u0BB5'
		}, {
			'\u0BB7', '\u0BB9'
		}, {
			'\u0C05', '\u0C0C'
		}, {
			'\u0C0E', '\u0C10'
		}, {
			'\u0C12', '\u0C28'
		}, {
			'\u0C2A', '\u0C33'
		}, {
			'\u0C35', '\u0C39'
		}, {
			'\u0C60', '\u0C61'
		}, {
			'\u0C85', '\u0C8C'
		}, {
			'\u0C8E', '\u0C90'
		}, {
			'\u0C92', '\u0CA8'
		}, {
			'\u0CAA', '\u0CB3'
		}, {
			'\u0CB5', '\u0CB9'
		}, {
			'\u0CDE', '\u0CDE'
		}, {
			'\u0CE0', '\u0CE1'
		}, {
			'\u0D05', '\u0D0C'
		}, {
			'\u0D0E', '\u0D10'
		}, {
			'\u0D12', '\u0D28'
		}, {
			'\u0D2A', '\u0D39'
		}, {
			'\u0D60', '\u0D61'
		}, {
			'\u0E01', '\u0E2E'
		}, {
			'\u0E30', '\u0E30'
		}, {
			'\u0E32', '\u0E33'
		}, {
			'\u0E40', '\u0E45'
		}, {
			'\u0E81', '\u0E82'
		}, {
			'\u0E84', '\u0E84'
		}, {
			'\u0E87', '\u0E88'
		}, {
			'\u0E8A', '\u0E8A'
		}, {
			'\u0E8D', '\u0E8D'
		}, {
			'\u0E94', '\u0E97'
		}, {
			'\u0E99', '\u0E9F'
		}, {
			'\u0EA1', '\u0EA3'
		}, {
			'\u0EA5', '\u0EA5'
		}, {
			'\u0EA7', '\u0EA7'
		}, {
			'\u0EAA', '\u0EAB'
		}, {
			'\u0EAD', '\u0EAE'
		}, {
			'\u0EB0', '\u0EB0'
		}, {
			'\u0EB2', '\u0EB3'
		}, {
			'\u0EBD', '\u0EBD'
		}, {
			'\u0EC0', '\u0EC4'
		}, {
			'\u0F40', '\u0F47'
		}, {
			'\u0F49', '\u0F69'
		}, {
			'\u10A0', '\u10C5'
		}, {
			'\u10D0', '\u10F6'
		}, {
			'\u1100', '\u1100'
		}, {
			'\u1102', '\u1103'
		}, {
			'\u1105', '\u1107'
		}, {
			'\u1109', '\u1109'
		}, {
			'\u110B', '\u110C'
		}, {
			'\u110E', '\u1112'
		}, {
			'\u113C', '\u113C'
		}, {
			'\u113E', '\u113E'
		}, {
			'\u1140', '\u1140'
		}, {
			'\u114C', '\u114C'
		}, {
			'\u114E', '\u114E'
		}, {
			'\u1150', '\u1150'
		}, {
			'\u1154', '\u1155'
		}, {
			'\u1159', '\u1159'
		}, {
			'\u115F', '\u1161'
		}, {
			'\u1163', '\u1163'
		}, {
			'\u1165', '\u1165'
		}, {
			'\u1167', '\u1167'
		}, {
			'\u1169', '\u1169'
		}, {
			'\u116D', '\u116E'
		}, {
			'\u1172', '\u1173'
		}, {
			'\u1175', '\u1175'
		}, {
			'\u119E', '\u119E'
		}, {
			'\u11A8', '\u11A8'
		}, {
			'\u11AB', '\u11AB'
		}, {
			'\u11AE', '\u11AF'
		}, {
			'\u11B7', '\u11B8'
		}, {
			'\u11BA', '\u11BA'
		}, {
			'\u11BC', '\u11C2'
		}, {
			'\u11EB', '\u11EB'
		}, {
			'\u11F0', '\u11F0'
		}, {
			'\u11F9', '\u11F9'
		}, {
			'\u1E00', '\u1E9B'
		}, {
			'\u1EA0', '\u1EF9'
		}, {
			'\u1F00', '\u1F15'
		}, {
			'\u1F18', '\u1F1D'
		}, {
			'\u1F20', '\u1F45'
		}, {
			'\u1F48', '\u1F4D'
		}, {
			'\u1F50', '\u1F57'
		}, {
			'\u1F59', '\u1F59'
		}, {
			'\u1F5B', '\u1F5B'
		}, {
			'\u1F5D', '\u1F5D'
		}, {
			'\u1F5F', '\u1F7D'
		}, {
			'\u1F80', '\u1FB4'
		}, {
			'\u1FB6', '\u1FBC'
		}, {
			'\u1FBE', '\u1FBE'
		}, {
			'\u1FC2', '\u1FC4'
		}, {
			'\u1FC6', '\u1FCC'
		}, {
			'\u1FD0', '\u1FD3'
		}, {
			'\u1FD6', '\u1FDB'
		}, {
			'\u1FE0', '\u1FEC'
		}, {
			'\u1FF2', '\u1FF4'
		}, {
			'\u1FF6', '\u1FFC'
		}, {
			'\u2126', '\u2126'
		}, {
			'\u212A', '\u212B'
		}, {
			'\u212E', '\u212E'
		}, {
			'\u2180', '\u2182'
		}, {
			'\u3041', '\u3094'
		}, {
			'\u30A1', '\u30FA'
		}, {
			'\u3105', '\u312C'
		}, {
			'\uAC00', '\uD7A3'
		}
	};

}