// Decompiled by DJ v2.9.9.61 Copyright 2000 Atanas Neshkov  Date: 31/03/2004 11:17:13
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   Tokenize.java

package com.wutka.dtd;

import java.io.File;
import java.io.PrintStream;
import java.util.Enumeration;
import java.util.Hashtable;

// Referenced classes of package com.wutka.dtd:
//			  DTDParser, DTDElement, DTDAttribute, DTDEntity, 
//			  DTDSystem, DTDPublic, DTDNotation, DTDAny, 
//			  DTDEmpty, DTDName, DTDChoice, DTDSequence, 
//			  DTDMixed, DTDPCData, DTDEnumeration, DTDNotationList, 
//			  DTD, DTDExternalID, DTDContainer, DTDItem, 
//			  DTDCardinal, DTDDecl

class Tokenize
{

	Tokenize()
	{
	}

	public static void main(String args[])
	{
		try
		{
			DTDParser dtdparser = new DTDParser(new File(args[0]), true);
			DTD dtd = dtdparser.parse(true);
			if(dtd.rootElement != null)
				System.out.println("Root element is probably: " + dtd.rootElement.name);
			for(Enumeration enumeration = dtd.elements.elements(); enumeration.hasMoreElements();)
			{
				DTDElement dtdelement = (DTDElement)enumeration.nextElement();
				System.out.println("Element: " + dtdelement.name);
				System.out.print("   Content: ");
				dumpDTDItem(dtdelement.content);
				System.out.println();
				if(dtdelement.attributes.size() > 0)
				{
					System.out.println("   Attributes: ");
					DTDAttribute dtdattribute;
					for(Enumeration enumeration3 = dtdelement.attributes.elements(); enumeration3.hasMoreElements(); dumpAttribute(dtdattribute))
					{
						System.out.print("        ");
						dtdattribute = (DTDAttribute)enumeration3.nextElement();
					}

					System.out.println();
				}
			}

			for(Enumeration enumeration1 = dtd.entities.elements(); enumeration1.hasMoreElements();)
			{
				DTDEntity dtdentity = (DTDEntity)enumeration1.nextElement();
				if(dtdentity.isParsed)
					System.out.print("Parsed ");
				System.out.println("Entity: " + dtdentity.name);
				if(dtdentity.value != null)
					System.out.println("    Value: " + dtdentity.value);
				if(dtdentity.externalID != null)
					if(dtdentity.externalID instanceof DTDSystem)
					{
						System.out.println("    System: " + dtdentity.externalID.system);
					} else
					{
						DTDPublic dtdpublic = (DTDPublic)dtdentity.externalID;
						System.out.println("    Public: " + dtdpublic.pub + " " + ((DTDExternalID) (dtdpublic)).system);
					}
				if(dtdentity.ndata != null)
					System.out.println("    NDATA " + dtdentity.ndata);
			}

			for(Enumeration enumeration2 = dtd.notations.elements(); enumeration2.hasMoreElements();)
			{
				DTDNotation dtdnotation = (DTDNotation)enumeration2.nextElement();
				System.out.println("Notation: " + dtdnotation.name);
				if(dtdnotation.externalID != null)
					if(dtdnotation.externalID instanceof DTDSystem)
					{
						System.out.println("    System: " + dtdnotation.externalID.system);
					} else
					{
						DTDPublic dtdpublic1 = (DTDPublic)dtdnotation.externalID;
						System.out.print("    Public: " + dtdpublic1.pub + " ");
						if(((DTDExternalID) (dtdpublic1)).system != null)
							System.out.println(((DTDExternalID) (dtdpublic1)).system);
						else
							System.out.println();
					}
			}

		}
		catch(Exception exception)
		{
			exception.printStackTrace(System.out);
		}
	}

	public static void dumpDTDItem(DTDItem dtditem)
	{
		if(dtditem == null)
			return;
		if(dtditem instanceof DTDAny)
			System.out.print("Any");
		else
		if(dtditem instanceof DTDEmpty)
			System.out.print("Empty");
		else
		if(dtditem instanceof DTDName)
			System.out.print(((DTDName)dtditem).value);
		else
		if(dtditem instanceof DTDChoice)
		{
			System.out.print("(");
			DTDItem adtditem[] = ((DTDChoice)dtditem).getItems();
			for(int i = 0; i < adtditem.length; i++)
			{
				if(i > 0)
					System.out.print("|");
				dumpDTDItem(adtditem[i]);
			}

			System.out.print(")");
		} else
		if(dtditem instanceof DTDSequence)
		{
			System.out.print("(");
			DTDItem adtditem1[] = ((DTDSequence)dtditem).getItems();
			for(int j = 0; j < adtditem1.length; j++)
			{
				if(j > 0)
					System.out.print(",");
				dumpDTDItem(adtditem1[j]);
			}

			System.out.print(")");
		} else
		if(dtditem instanceof DTDMixed)
		{
			System.out.print("(");
			DTDItem adtditem2[] = ((DTDMixed)dtditem).getItems();
			for(int k = 0; k < adtditem2.length; k++)
			{
				if(k > 0)
					System.out.print(",");
				dumpDTDItem(adtditem2[k]);
			}

			System.out.print(")");
		} else
		if(dtditem instanceof DTDPCData)
			System.out.print("#PCDATA");
		if(dtditem.cardinal == DTDCardinal.OPTIONAL)
			System.out.print("?");
		else
		if(dtditem.cardinal == DTDCardinal.ZEROMANY)
			System.out.print("*");
		else
		if(dtditem.cardinal == DTDCardinal.ONEMANY)
			System.out.print("+");
	}

	public static void dumpAttribute(DTDAttribute dtdattribute)
	{
		System.out.print(dtdattribute.name + " ");
		if(dtdattribute.type instanceof String)
			System.out.print(dtdattribute.type);
		else
		if(dtdattribute.type instanceof DTDEnumeration)
		{
			System.out.print("(");
			String as[] = ((DTDEnumeration)dtdattribute.type).getItems();
			for(int i = 0; i < as.length; i++)
			{
				if(i > 0)
					System.out.print(",");
				System.out.print(as[i]);
			}

			System.out.print(")");
		} else
		if(dtdattribute.type instanceof DTDNotationList)
		{
			System.out.print("Notation (");
			String as1[] = ((DTDNotationList)dtdattribute.type).getItems();
			for(int j = 0; j < as1.length; j++)
			{
				if(j > 0)
					System.out.print(",");
				System.out.print(as1[j]);
			}

			System.out.print(")");
		}
		if(dtdattribute.decl != null)
			System.out.print(" " + dtdattribute.decl.name);
		if(dtdattribute.defaultValue != null)
			System.out.print(" " + dtdattribute.defaultValue);
		System.out.println();
	}
}